// 001 u_c_session_list
// 04 mar 00

(*$r+*)

unit u_c_sas_parameter_list_2;
  interface
    uses Classes, u_c_basic_object;

    type c_sas_parameter= // one "sas_parameter"
             Class(c_basic_object)
               // -- m_name: the title of the parameter

               m_policy: String;
               m_employee_rate, m_company_rate: Double;

               Constructor create_sas_parameter(p_name: String);
               function f_c_self: c_sas_parameter;

               function f_display_sas_parameter: String;

               Destructor Destroy; Override;
             end; // c_sas_parameter

         c_sas_parameter_list_2= // "sas_parameter" list
             Class(c_basic_object)
               m_c_sas_parameter_list: tStringList;

               m_title: String;

               Constructor create_sas_parameter_list_2(p_name: String);

               function f_c_self: c_sas_parameter_list_2;
               function f_sas_parameter_count: Integer;
               function f_c_sas_parameter(p_sas_parameter_index: Integer): c_sas_parameter;
               function f_index_of_sas_parameter(p_sas_parameter_name: String): Integer;
               function f_c_find_sas_parameter_by_name(p_sas_parameter_name: String): c_sas_parameter;
               procedure add_sas_parameter(p_sas_parameter_name: String; p_c_sas_parameter: c_sas_parameter);
               function f_c_add_sas_parameter(p_sas_parameter_name: String): c_sas_parameter;
               function f_c_add_unique_sas_parameter(p_sas_parameter_name: String): c_sas_parameter;

               procedure display_sas_parameter_list;

               procedure load_from_file(p_path, p_file_name: String);

               function f_c_delete_sas_parameter(p_sas_parameter_index: Integer): c_sas_parameter;
               procedure clear_sas_parameter;
               Destructor Destroy; Override;
             end; // c_sas_parameter_list

  implementation
    uses SysUtils, u_c_display
        , u_strings, u_stringlist, u_c_stringlist
        ;

    // -- c_sas_parameter

    Constructor c_sas_parameter.create_sas_parameter(p_name: String);
      begin
        Inherited create_basic_object(p_name);
      end; // create_sas_parameter

    function c_sas_parameter.f_display_sas_parameter: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_sas_parameter

    function c_sas_parameter.f_c_self: c_sas_parameter;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_sas_parameter.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_sas_parameter_list

    Constructor c_sas_parameter_list_2.create_sas_parameter_list_2(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_sas_parameter_list:= tStringList.Create;
      end; // create_sas_parameter_list_2

    function c_sas_parameter_list_2.f_c_self: c_sas_parameter_list_2;
      begin
        Result:= Self;
      end; // f_c_self

    function c_sas_parameter_list_2.f_sas_parameter_count: Integer;
      begin
        Result:= m_c_sas_parameter_list.Count;
      end; // f_sas_parameter_count

    function c_sas_parameter_list_2.f_c_sas_parameter(p_sas_parameter_index: Integer): c_sas_parameter;
      begin
        Result:= c_sas_parameter(m_c_sas_parameter_list.Objects[p_sas_parameter_index]);
      end; //  f_c_sas_parameter

    function c_sas_parameter_list_2.f_index_of_sas_parameter(p_sas_parameter_name: String): Integer;
      begin
        Result:= m_c_sas_parameter_list.IndexOf(p_sas_parameter_name);
      end; // f_index_of_sas_parameter

    function c_sas_parameter_list_2.f_c_find_sas_parameter_by_name(p_sas_parameter_name: String): c_sas_parameter;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of_sas_parameter(p_sas_parameter_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_sas_parameter(m_c_sas_parameter_list.Objects[l_index_of]);
      end; // f_c_find_sas_parameter_by_name

    procedure c_sas_parameter_list_2.add_sas_parameter(p_sas_parameter_name: String; p_c_sas_parameter: c_sas_parameter);
      begin
        m_c_sas_parameter_list.AddObject(p_sas_parameter_name, p_c_sas_parameter);
      end; // add_sas_parameter

    function c_sas_parameter_list_2.f_c_add_sas_parameter(p_sas_parameter_name: String): c_sas_parameter;
      begin
        Result:= c_sas_parameter.create_sas_parameter(p_sas_parameter_name);
        add_sas_parameter(p_sas_parameter_name, Result);
      end; // f_c_add_sas_parameter

    function c_sas_parameter_list_2.f_c_add_unique_sas_parameter(p_sas_parameter_name: String): c_sas_parameter;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of_sas_parameter(p_sas_parameter_name);
        if l_index_of>= 0
          then Result:= f_c_sas_parameter(l_index_of)
          else Result:= f_c_add_sas_parameter(p_sas_parameter_name);
      end; // f_c_add_unique_sas_parameter

    procedure c_sas_parameter_list_2.display_sas_parameter_list;
      var l_sas_parameter_index: Integer;
          l_employee_rate, l_company_rate: string;
      begin
        // display(m_name+ ' '+ IntToStr(f_sas_parameter_count));
        display_line;
        display(m_title);

        for l_sas_parameter_index:= 0 to f_sas_parameter_count- 1 do
          with f_c_sas_parameter(l_sas_parameter_index) do
          begin
            if m_name= ''
              then display_line
              else begin
                  if m_policy= ''
                    then begin
                        l_employee_rate:= '        ';
                        l_company_rate:= '        ';
                      end
                    else begin
                        if m_employee_rate= 0
                          then l_employee_rate:= '       -'
                          else l_employee_rate:= Format('%8.4f', [m_employee_rate]);
                        if m_company_rate= 0
                          then l_company_rate:= '       -'
                          else l_company_rate:= Format('%8.4f', [m_company_rate]);
                      end;

                  display(Format('%-27s %-12s %-10s %-10s',
                      [m_name, m_policy, l_employee_rate, l_company_rate]));
                end;
          end;
      end; // display_sas_parameter_list

    procedure c_sas_parameter_list_2.load_from_file(p_path, p_file_name: String);
      var l_c_parameter_stringlist: c_stringlist;

      function _f_next_value: String;
        var l_value: String;
        begin
          l_value:= l_c_parameter_stringlist.f_next_value;

          if (l_value= '') or (l_value= '-')
            then Result:= '0'
            else Result:= l_value;
        end; // _f_next_value

      var l_key, l_policy, l_employee_value, l_company_value: String;

      begin // load_from_file
        l_c_parameter_stringlist:= c_stringlist.create_stringlist('', p_path, p_file_name);

        with l_c_parameter_stringlist do
        begin
          stop_if_empty;
          display(m_c_stringlist.Text);

          while not f_end_of_file do
          begin
            display(m_the_line);

            if not f_is_blank_or_comment
              then begin
                  l_key:= f_next_value;
                  l_policy:= f_next_value;
                  // l_key:= f_replace_character(l_key, '-', '_');
                  if l_policy= ''
                    then l_key:= f_spaces(m_indentation)+ l_key;
                  l_employee_value:= _f_next_value; l_company_value:= _f_next_value;
                  with f_c_add_sas_parameter(l_key) do
                  begin
                    m_policy:= l_policy;
                    m_employee_rate:= StrToFloat(l_employee_value);
                    m_company_rate:= StrToFloat(l_company_value);
                  end;
                end
              else
                if (m_title= '') and (m_trimmed_line<> '')
                  then m_title:= m_trimmed_line
                  else
                    with f_c_add_sas_parameter(m_the_line) do
                      if m_trimmed_line= ''
                        then m_name:= '';

            read_line;
          end; // while not f_end_of_file

          Free;
        end; // with l_c_parameter_stringlist
        display(m_c_sas_parameter_list.Text);
      end; // load_from_file

    // -- delete / free

    function c_sas_parameter_list_2.f_c_delete_sas_parameter(p_sas_parameter_index: Integer): c_sas_parameter;
      begin
        Result:= f_c_sas_parameter(p_sas_parameter_index);
        m_c_sas_parameter_list.Delete(p_sas_parameter_index);
      end; // f_c_delete_sas_parameter

    procedure c_sas_parameter_list_2.clear_sas_parameter;
      var l_sas_parameter_index: Integer;
      begin
        for l_sas_parameter_index:= 0 to f_sas_parameter_count- 1 do
          f_c_sas_parameter(l_sas_parameter_index).Free;
        m_c_sas_parameter_list.Clear;
      end; // clear_sas_parameter

    Destructor c_sas_parameter_list_2.Destroy;
      var l_sas_parameter_index: Integer;
      begin
        for l_sas_parameter_index:= 0 to f_sas_parameter_count- 1 do
          f_c_sas_parameter(l_sas_parameter_index).Free;
        m_c_sas_parameter_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_sas_parameter_list
    end. // u_c_sas_parameter_list
